<html devsite><head>
    <title>兼容性测试套件</title>
    <meta name="project_path" value="/_project.yaml"/>
    <meta name="book_path" value="/_book.yaml"/>
  </head>
  <body>
  <!--
      Copyright 2017 The Android Open Source Project

      Licensed under the Apache License, Version 2.0 (the "License");
      you may not use this file except in compliance with the License.
      You may obtain a copy of the License at

          http://www.apache.org/licenses/LICENSE-2.0

      Unless required by applicable law or agreed to in writing, software
      distributed under the License is distributed on an "AS IS" BASIS,
      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
      See the License for the specific language governing permissions and
      limitations under the License.
  -->

<h2 id="how-does-the-cts-work">CTS 的工作原理是什么？</h2>

<p>兼容性测试套件 (CTS) 是一个免费的商业级测试套件，可在<a href="/compatibility/cts/downloads">此处下载</a>。CTS 代表兼容性的“机制”。</p>

<p>CTS 在桌面设备上运行，并直接在连接的设备或模拟器上执行测试用例。CTS 是一套单元测试，旨在集成到工程师构建设备的日常工作流程（例如通过连续构建系统）中。其目的是尽早发现不兼容性，并确保软件在整个开发过程中保持兼容性。</p>

<p>CTS 是一个自动化测试工具，其中包括两个主要软件组件：</p>
<ul>
<li>
CTS tradefed 自动化测试框架会在桌面设备上运行，并管理测试执行情况。
</li>
<li>
单独的测试用例会在被测设备 (DUT) 上执行。测试用例采用 Java 语言编写为 JUnit 测试，并打包为 Android .apk 文件，以在实际目标设备上运行。
</li>
</ul>

<p>兼容性测试套件验证程序（CTS 验证程序）是对 CTS（可在<a href="/compatibility/cts/downloads">此处下载</a>）的补充。CTS 验证程序为无法在没有手动输入（例如音频质量、加速度计等）的固定设备上进行测试的 API 和功能提供测试。</p>

<p>CTS 验证程序是一款手动测试工具，包含以下软件组件：</p>
<ul>
<li>
<p>在 DUT 上执行并收集结果的 CTS 验证程序应用。</p><p>
</p></li>
<li>
<p>在桌面设备上执行，以便为 CTS 验证程序应用中的某些测试用例提供数据或额外控制的可执行文件或脚本。</p>
</li>
</ul>

<h2 id="workflow">工作流程</h2>

<div class="attempt-right" style="width:383px">
  <img src="/compatibility/cts/images/cts-0.png" alt="CTS 流程" height="340px" id="figure1"/>
  <p class="img-caption">
    <strong>图 1.</strong> 如何使用 CTS
  </p>
</div>

<p>上图总结了 CTS 工作流程。有关详细说明，请参阅本部分的子页面（从<a href="/compatibility/cts/setup">设置</a>开始）。</p>

<h2 id="types-of-test-cases">测试用例的类型</h2>
<p>CTS 包含以下类型的测试用例：</p>
<ul>
<li>
<em></em>单元测试会测试 Android 平台中很微小的代码元素；例如 java.util.HashMap 等单个类。
</li>
<li>
<p><em></em>功能测试会通过较高级别的用例将 API 组合到一起进行测试。</p>
</li>
</ul>
CTS 的未来版本将包含以下类型的测试用例：
<ul>
<li>
<em></em>稳健性测试会测试系统在压力下的耐久性。
</li>
<li>
<em></em>性能测试会根据定义的基准测试系统的性能（例如每秒渲染帧数）。
</li>
</ul>
<h2 id="areas-covered">涵盖的领域</h2>
<p>单元测试用例涵盖以下领域，以确保兼容性：</p>
<table>
<thead>
<tr>
<th>领域</th>
<th>说明</th>
</tr>
</thead>
<tbody>
<tr>
<td>签名测试</td>
<td>每个 Android 版本中都包含一个 XML 文件，用于描述这一版本所含的所有公开 API 的签名。CTS 包含一个实用工具，用于根据设备上可用的 API 检查这些 API 签名。签名检查的结果会记录在测试结果 XML 文件中。</td>
</tr>
<tr>
<td>平台 API 测试</td>
<td>按照 SDK <a href="https://developer.android.com/reference/classes">类索引</a>所述内容来测试平台（核心库和 Android 应用框架）的 API，以确保 API 的正确性，包括正确的类、属性、方法签名以及正确的方法行为；此外还需进行负面测试，以确保不正确的参数处理产生预期行为。</td>
</tr>
<tr>
<td>Dalvik 测试</td>
<td>这类测试侧重于测试 Dalvik 可执行格式的文件。</td>
</tr>
<tr>
<td>平台数据模型</td>
<td>CTS 会测试通过内容提供程序（如 SDK <a href="https://developer.android.com/reference/android/provider/package-summary">android.provider</a> 软件包中所述）提供给应用开发者的核心平台数据模型：通讯录、浏览器、设置等。</td>
</tr>
<tr>
<td>平台 Intent</td>
<td>CTS 会测试核心平台 Intent（如 SDK <a href="https://developer.android.com/guide/appendix/g-app-intents">可用 Intent</a> 中所述）。</td>
</tr>
<tr>
<td>平台权限</td>
<td>CTS 会测试核心平台权限（如 SDK <a href="https://developer.android.com/reference/android/Manifest.permission">可用权限</a>中所述）。</td>
</tr>
<tr>
<td>平台资源</td>
<td>CTS 会测试核心平台资源类型（如 SDK <a href="https://developer.android.com/guide/topics/resources/available-resources">可用资源类型</a>中所述）的处理是否正确。这包括对以下资源的测试：简单值、可绘制资源、九宫格、动画、布局、样式和主题背景，以及加载备用资源。</td>
</tr>
</tbody>
</table>

</body></html>